Updates to the Cipher Suites in Secure Syslog
Internet-Draft draft-ietf-uta-ciphersuites-in-sec-syslog-07
Chris Lonvick
lonvick.ietf@gmail.com
Sean Turner
sn3rd
sean@sn3rd.com
Joe Salowey
Venafi
joe@salowey.net
2024
Applications and Real-Time Area
Internet Engineering Task Force
syslog
secure syslog
TLS_RSA_WITH_AES_128_CBC_SHA
TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256
DTLS
TLS
cipher suite
The IETF published two specifications, namely RFC 5425 and RFC 6012, for securing the Syslog protocol using TLS and DTLS, respectively.
This document updates the cipher suites in RFC 5425, Transport Layer Security (TLS) Transport Mapping for Syslog, and RFC 6012, Datagram Transport Layer Security (DTLS) Transport Mapping for Syslog. It also updates the transport protocol in RFC 6012.
Introduction
The IETF published RFC 5425, Transport Layer Security (TLS) Transport Mapping for Syslog, and RFC 6012, Datagram Transport Layer Security (DTLS) Transport Mapping for Syslog.
Both specifications, [RFC5425] and [RFC6012], require the use of RSA-based certificates and the use of TLS/DTLS versions that are not the most recent.
[RFC5425] requires that implementations "MUST" support TLS 1.2 [RFC5246] and are "REQUIRED" to support the mandatory to implement cipher suite TLS_RSA_WITH_AES_128_CBC_SHA (Section 4.2).
[RFC6012] requires that implementations "MUST" support DTLS 1.0 [RFC4347] and are also "REQUIRED" to support the mandatory to implement cipher suite TLS_RSA_WITH_AES_128_CBC_SHA (Section 5.2).
The community is moving away from cipher suits that don't offer forward secrecy and towards more robust suites.
The DTLS 1.0 transport [RFC4347] has been deprecated by [BCP195] and the community is moving to DTLS 1.2 [RFC6347] and DTLS 1.3 [RFC9147].
This document updates [RFC5425] and [RFC6012] to prefer the use of TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 over the use of TLS_RSA_WITH_AES_128_CBC_SHA.
This document also updates [RFC6012] to make a recommendation of a mandatory to implement secure datagram transport.

Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [[RFC2119]] [[RFC8174]] when, and only when, they appear in all capitals, as shown here.

Support for Updating
[draft-ietf-tls-rfc8447bis-09] generally reminds us that cryptographic algorithms and parameters will be broken or weakened over time. Blindly implementing the cryptographic algorithms listed in any specification is not advised. Implementers and users need to check that the cryptographic algorithms specified continue to provide the expected level of security.
As the Syslog Working Group determined, Syslog clients and servers MUST use certificates as defined in [RFC5280]. Since both [RFC5425] and [RFC6012] REQUIRED the use of TLS_RSA_WITH_AES_128_CBC_SHA, it is very likely that RSA certificates have been implemented in devices adhering to those specifications. [BCP195] notes that ECDHE cipher suites exist for both RSA and ECDSA certificates, so moving to an ECDHE cipher suite will not require replacing or moving away from any currently installed RSA-based certificates.
[draft-ietf-tls-deprecate-obsolete-kex-04] documents that the cipher suite TLS_RSA_WITH_AES_128_CBC_SHA, along with some other cipher suites, may require mitigation techniques to achieve expected security, which may be difficult to effectively implement. Along those lines, [BCP195] [[RFC9325]] notes that TLS_RSA_WITH_AES_128_CBC_SHA does not provide forward secrecy, a feature that is highly desirable in securing event messages. That document also goes on to recommend TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 as a cipher suite that does provide forward secrecy.
As such, the community is moving away from algorithms that do not provide forward secrecy. For example, the International Electrotechnical Commission (IEC) has selected more robust suites such as TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256, which is also listed as a currently RECCOMENDED algorithm in [draft-ietf-tls-rfc8447bis-09] for their deployments of secure syslog.
Additionally, [BCP195] [[RFC8996]] deprecates the use of DTLS 1.0 [RFC4347], which is the mandatory to implement transport protocol for [RFC6012]. Therefore, the transport protocol for [RFC6012] must be updated.
Finally, [BCP195] ([RFC9325]) provides guidance on the support of [RFC8446] and [RFC9147].
Therefore, to maintain interoperability across implementations, the mandatory to implement cipher suites listed in [RFC5425] and [RFC6012] should be updated so that implementations of secure syslog will still interoperate and provide an acceptable and expected level of security.
However, since there are many implementations of syslog using the cipher suites mandatated to be used in [RFC6012], a sudden change is not desireable. To accomodate a migration path, this specification will allow the use of both TLS_RSA_WITH_AES_128_CBC_SHA and TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 but REQUIRES that TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 be preferred.

Updates to RFC 5425
The mandatory to implement cipher suites are REQUIRED to be TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 and TLS_RSA_WITH_AES_128_CBC_SHA.
Implementations of [RFC5425] SHOULD offer TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 but MAY offer TLS_RSA_WITH_AES_128_CBC_SHA.
Implementations of [RFC5425] MUST continue to use TLS 1.2 [RFC5246] as the mandatory to implement transport protocol.
As per [BCP195], implementations of [RFC5425] SHOULD support TLS 1.3 [RFC8446] and, if implemented, MUST prefer to negotiate TLS 1.3 over earlier versions of TLS.

Updates to RFC 6012
The mandatory to implement cipher suites are REQUIRED to be TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 and TLS_RSA_WITH_AES_128_CBC_SHA.
Implementations of [RFC6012] SHOULD offer TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 but MAY offer TLS_RSA_WITH_AES_128_CBC_SHA.
As specified in [BCP195], implementations of [RFC6012] MUST NOT use DTLS 1.0 [RFC4347]. Implementations MUST use DTLS 1.2 [RFC6347].
DTLS 1.2 [RFC6347] implementations SHOULD support and prefer the mandatory to implement cipher suite TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256.
As per [BCP195], implementations of [RFC6012] SHOULD support DTLS 1.3 [RFC9147] and, if implemented, MUST prefer to negotiate DTLS version 1.3 over earlier versions of DTLS.

Early Data
Early data (aka 0-RTT data) is a mechanism defined in TLS 1.3 [RFC8446] that allows a client to send data ("early data") as part of the first flight of messages to a server. Early data is permitted by TLS 1.3 when the client and server share a PSK, either obtained externally or via a previous handshake. The client uses the PSK to authenticate the server and to encrypt the early data.
As noted in Section 2.3 of [draft-ietf-tls-rfc8446bis-09], the security properties for early data are weaker than those for subsequent TLS-protected data. In particular, early data is not forward secret, and there are no protections against the replay of early data between connections. Appendix E.5 of [draft-ietf-tls-rfc8446bis-09] requires applications not use early data without a profile that defines its use. Because syslog does not support replay protection, see Section 8.4 of [RFC5424]", and most implementations establish a long-lived connection, this document specifies that implementations MUST NOT use early data.

Authors Notes
This section will be removed prior to publication.
This is version -07 for the UTA Working Group. These edits reflect comments from IESG review.
Acknowledgments
The authors would like to thank Arijit Kumar Bose, Steffen Fries and the members of IEC TC57 WG15 for their review, comments, and suggestions. The authors would also like to thank Tom Petch, Juergen Schoenwaelder, Hannes Tschofenig, Viktor Dukhovni, and the IESG members for their comments and constructive feedback.
IANA Considerations
This document makes no requests to IANA.
Security Considerations
[BCP195] deprecates an insecure DTLS transport protocol from [RFC6012] and deprecates insecure cipher suits from [RFC5425] and [RFC6012]. However, the installed base of syslog implementations is not easily updated to immediately adhere to those changes.
This document updates the mandatory to implement cipher suites to allow for a migration from TLS_RSA_WITH_AES_128_CBC_SHA to TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 without deprecating the former. Implementations should prefer to use TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256.
If a device currently only has TLS_RSA_WITH_AES_128_CBC_SHA, an administrator of the network should evaluate the conditions and determine if TLS_RSA_WITH_AES_128_CBC_SHA should be allowed so that syslog messages may continue to be delivered until the device is updated to have TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC5425]

Transport Layer Security (TLS) Transport Mapping for Syslog
F. Miao, Ed.
Y. Ma, Ed.
J. Salowey, Ed.
March 2009
RFC 5425
DOI 10.17487/RFC5425
[RFC5246]

The Transport Layer Security (TLS) Protocol Version 1.2
T. Dierks
E. Rescorla
August 2008
RFC 5246
DOI 10.17487/RFC5246
[RFC5424]

The Syslog Protocol
R. Gerhards
March 2009
RFC 5424
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC6347]

Datagram Transport Layer Security Version 1.2
E. Rescorla
N. Modadugu
January 2012
RFC 6347
DOI 10.17487/RFC6347
[RFC4347]

Datagram Transport Layer Security
E. Rescorla
N. Modadugu
April 2006
RFC 4347
DOI 10.17487/RFC4347
[RFC6012]

Datagram Transport Layer Security (DTLS) Transport Mapping for Syslog
J. Salowey
T. Petch
R. Gerhards
H. Feng
October 2010
RFC 6012
DOI 10.17487/RFC6012
[RFC5280]

Internet X.509 Public Key Infrastructure Certificate and Certificate Revocation List (CRL) Profile
D. Cooper
S. Santesson
S. Farrell
S. Boeyen
R. Housley
W. Polk
May 2008
RFC 5280
DOI 10.17487/RFC5280
[RFC8996]

Deprecating TLS 1.0 and TLS 1.1
K. Moriarty
S. Farrell
March 2021
BCP 195
RFC 8996
DOI 10.17487/RFC8996
[RFC9325]

Recommendations for Secure Use of Transport Layer Security (TLS) and Datagram Transport Layer Security (DTLS)
Y. Sheffer
P. Saint-Andre
T. Fossati
November 2022
BCP 195
RFC 9325
DOI 10.17487/RFC9325
[RFC9147]

The Datagram Transport Layer Security (DTLS) Protocol Version 1.3
E. Rescorla
H. Tschofenig
N. Modadugu
April 2022
RFC 9147
DOI 10.17487/RFC9147
Informative References
[draft-ietf-tls-rfc8447bis-09]

IANA Registry Updates for TLS and DTLS
Joseph A. Salowey
Venafi
Sean Turner
sn3rd
28 March 2023
Internet-Draft draft-ietf-tls-rfc8447bis-09
[draft-ietf-tls-deprecate-obsolete-kex-04]

Deprecating Obsolete Key Exchange Methods in TLS
Carrick Bartle
Apple, Inc.
Nimrod Aviram
11 July 2023
Internet-Draft draft-ietf-tls-deprecate-obsolete-kex-04
[draft-ietf-tls-rfc8446bis-09]

The Transport Layer Security (TLS) Protocol Version 1.3
Eric Rescorla
Mozilla
7 July 2023
Internet-Draft draft-ietf-tls-rfc8446bis-09